diff --git a/gcc/tree-pass.h b/gcc/tree-pass.h
index b8c59a7..24e5d20 100644
--- a/gcc/tree-pass.h
+++ b/gcc/tree-pass.h
@@ -257,238 +257,238 @@ struct register_pass_info
   enum pass_positioning_ops pos_op; /* how to insert the new pass.  */
 };
 
-extern struct gimple_opt_pass pass_mudflap_1;
-extern struct gimple_opt_pass pass_mudflap_2;
-extern struct gimple_opt_pass pass_asan;
-extern struct gimple_opt_pass pass_asan_O0;
-extern struct gimple_opt_pass pass_tsan;
-extern struct gimple_opt_pass pass_tsan_O0;
-extern struct gimple_opt_pass pass_lower_cf;
-extern struct gimple_opt_pass pass_refactor_eh;
-extern struct gimple_opt_pass pass_lower_eh;
-extern struct gimple_opt_pass pass_lower_eh_dispatch;
-extern struct gimple_opt_pass pass_lower_resx;
-extern struct gimple_opt_pass pass_build_cfg;
-extern struct gimple_opt_pass pass_early_tree_profile;
-extern struct gimple_opt_pass pass_cleanup_eh;
-extern struct gimple_opt_pass pass_sra;
-extern struct gimple_opt_pass pass_sra_early;
-extern struct gimple_opt_pass pass_early_ipa_sra;
-extern struct gimple_opt_pass pass_tail_recursion;
-extern struct gimple_opt_pass pass_tail_calls;
-extern struct gimple_opt_pass pass_tree_loop;
-extern struct gimple_opt_pass pass_tree_loop_init;
-extern struct gimple_opt_pass pass_lim;
-extern struct gimple_opt_pass pass_tree_unswitch;
-extern struct gimple_opt_pass pass_predcom;
-extern struct gimple_opt_pass pass_iv_canon;
-extern struct gimple_opt_pass pass_scev_cprop;
-extern struct gimple_opt_pass pass_empty_loop;
-extern struct gimple_opt_pass pass_record_bounds;
-extern struct gimple_opt_pass pass_graphite;
-extern struct gimple_opt_pass pass_graphite_transforms;
-extern struct gimple_opt_pass pass_if_conversion;
-extern struct gimple_opt_pass pass_loop_distribution;
-extern struct gimple_opt_pass pass_vectorize;
-extern struct gimple_opt_pass pass_slp_vectorize;
-extern struct gimple_opt_pass pass_complete_unroll;
-extern struct gimple_opt_pass pass_complete_unrolli;
-extern struct gimple_opt_pass pass_parallelize_loops;
-extern struct gimple_opt_pass pass_loop_prefetch;
-extern struct gimple_opt_pass pass_iv_optimize;
-extern struct gimple_opt_pass pass_tree_loop_done;
-extern struct gimple_opt_pass pass_ch;
-extern struct gimple_opt_pass pass_ccp;
-extern struct gimple_opt_pass pass_phi_only_cprop;
-extern struct gimple_opt_pass pass_build_ssa;
-extern struct gimple_opt_pass pass_build_alias;
-extern struct gimple_opt_pass pass_build_ealias;
-extern struct gimple_opt_pass pass_dominator;
-extern struct gimple_opt_pass pass_dce;
-extern struct gimple_opt_pass pass_dce_loop;
-extern struct gimple_opt_pass pass_cd_dce;
-extern struct gimple_opt_pass pass_call_cdce;
-extern struct gimple_opt_pass pass_merge_phi;
-extern struct gimple_opt_pass pass_split_crit_edges;
-extern struct gimple_opt_pass pass_pre;
+extern gimple_opt_pass *make_pass_mudflap_1 (context &ctxt);
+extern gimple_opt_pass *make_pass_mudflap_2 (context &ctxt);
+extern gimple_opt_pass *make_pass_asan (context &ctxt);
+extern gimple_opt_pass *make_pass_asan_O0 (context &ctxt);
+extern gimple_opt_pass *make_pass_tsan (context &ctxt);
+extern gimple_opt_pass *make_pass_tsan_O0 (context &ctxt);
+extern gimple_opt_pass *make_pass_lower_cf (context &ctxt);
+extern gimple_opt_pass *make_pass_refactor_eh (context &ctxt);
+extern gimple_opt_pass *make_pass_lower_eh (context &ctxt);
+extern gimple_opt_pass *make_pass_lower_eh_dispatch (context &ctxt);
+extern gimple_opt_pass *make_pass_lower_resx (context &ctxt);
+extern gimple_opt_pass *make_pass_build_cfg (context &ctxt);
+extern gimple_opt_pass *make_pass_early_tree_profile (context &ctxt);
+extern gimple_opt_pass *make_pass_cleanup_eh (context &ctxt);
+extern gimple_opt_pass *make_pass_sra (context &ctxt);
+extern gimple_opt_pass *make_pass_sra_early (context &ctxt);
+extern gimple_opt_pass *make_pass_early_ipa_sra (context &ctxt);
+extern gimple_opt_pass *make_pass_tail_recursion (context &ctxt);
+extern gimple_opt_pass *make_pass_tail_calls (context &ctxt);
+extern gimple_opt_pass *make_pass_tree_loop (context &ctxt);
+extern gimple_opt_pass *make_pass_tree_loop_init (context &ctxt);
+extern gimple_opt_pass *make_pass_lim (context &ctxt);
+extern gimple_opt_pass *make_pass_tree_unswitch (context &ctxt);
+extern gimple_opt_pass *make_pass_predcom (context &ctxt);
+extern gimple_opt_pass *make_pass_iv_canon (context &ctxt);
+extern gimple_opt_pass *make_pass_scev_cprop (context &ctxt);
+extern gimple_opt_pass *make_pass_empty_loop (context &ctxt);
+extern gimple_opt_pass *make_pass_record_bounds (context &ctxt);
+extern gimple_opt_pass *make_pass_graphite (context &ctxt);
+extern gimple_opt_pass *make_pass_graphite_transforms (context &ctxt);
+extern gimple_opt_pass *make_pass_if_conversion (context &ctxt);
+extern gimple_opt_pass *make_pass_loop_distribution (context &ctxt);
+extern gimple_opt_pass *make_pass_vectorize (context &ctxt);
+extern gimple_opt_pass *make_pass_slp_vectorize (context &ctxt);
+extern gimple_opt_pass *make_pass_complete_unroll (context &ctxt);
+extern gimple_opt_pass *make_pass_complete_unrolli (context &ctxt);
+extern gimple_opt_pass *make_pass_parallelize_loops (context &ctxt);
+extern gimple_opt_pass *make_pass_loop_prefetch (context &ctxt);
+extern gimple_opt_pass *make_pass_iv_optimize (context &ctxt);
+extern gimple_opt_pass *make_pass_tree_loop_done (context &ctxt);
+extern gimple_opt_pass *make_pass_ch (context &ctxt);
+extern gimple_opt_pass *make_pass_ccp (context &ctxt);
+extern gimple_opt_pass *make_pass_phi_only_cprop (context &ctxt);
+extern gimple_opt_pass *make_pass_build_ssa (context &ctxt);
+extern gimple_opt_pass *make_pass_build_alias (context &ctxt);
+extern gimple_opt_pass *make_pass_build_ealias (context &ctxt);
+extern gimple_opt_pass *make_pass_dominator (context &ctxt);
+extern gimple_opt_pass *make_pass_dce (context &ctxt);
+extern gimple_opt_pass *make_pass_dce_loop (context &ctxt);
+extern gimple_opt_pass *make_pass_cd_dce (context &ctxt);
+extern gimple_opt_pass *make_pass_call_cdce (context &ctxt);
+extern gimple_opt_pass *make_pass_merge_phi (context &ctxt);
+extern gimple_opt_pass *make_pass_split_crit_edges (context &ctxt);
+extern gimple_opt_pass *make_pass_pre (context &ctxt);
 extern unsigned int tail_merge_optimize (unsigned int);
-extern struct gimple_opt_pass pass_profile;
-extern struct gimple_opt_pass pass_strip_predict_hints;
-extern struct gimple_opt_pass pass_lower_complex_O0;
-extern struct gimple_opt_pass pass_lower_complex;
-extern struct gimple_opt_pass pass_lower_vector;
-extern struct gimple_opt_pass pass_lower_vector_ssa;
-extern struct gimple_opt_pass pass_lower_omp;
-extern struct gimple_opt_pass pass_diagnose_omp_blocks;
-extern struct gimple_opt_pass pass_expand_omp;
-extern struct gimple_opt_pass pass_expand_omp_ssa;
-extern struct gimple_opt_pass pass_object_sizes;
-extern struct gimple_opt_pass pass_strlen;
-extern struct gimple_opt_pass pass_fold_builtins;
-extern struct gimple_opt_pass pass_stdarg;
-extern struct gimple_opt_pass pass_early_warn_uninitialized;
-extern struct gimple_opt_pass pass_late_warn_uninitialized;
-extern struct gimple_opt_pass pass_cse_reciprocals;
-extern struct gimple_opt_pass pass_cse_sincos;
-extern struct gimple_opt_pass pass_optimize_bswap;
-extern struct gimple_opt_pass pass_optimize_widening_mul;
-extern struct gimple_opt_pass pass_warn_function_return;
-extern struct gimple_opt_pass pass_warn_function_noreturn;
-extern struct gimple_opt_pass pass_cselim;
-extern struct gimple_opt_pass pass_phiopt;
-extern struct gimple_opt_pass pass_forwprop;
-extern struct gimple_opt_pass pass_phiprop;
-extern struct gimple_opt_pass pass_tree_ifcombine;
-extern struct gimple_opt_pass pass_dse;
-extern struct gimple_opt_pass pass_nrv;
-extern struct gimple_opt_pass pass_rename_ssa_copies;
-extern struct gimple_opt_pass pass_sink_code;
-extern struct gimple_opt_pass pass_fre;
-extern struct gimple_opt_pass pass_check_data_deps;
-extern struct gimple_opt_pass pass_copy_prop;
-extern struct gimple_opt_pass pass_vrp;
-extern struct gimple_opt_pass pass_uncprop;
-extern struct gimple_opt_pass pass_return_slot;
-extern struct gimple_opt_pass pass_reassoc;
-extern struct gimple_opt_pass pass_rebuild_cgraph_edges;
-extern struct gimple_opt_pass pass_remove_cgraph_callee_edges;
-extern struct gimple_opt_pass pass_build_cgraph_edges;
-extern struct gimple_opt_pass pass_local_pure_const;
-extern struct gimple_opt_pass pass_tracer;
-extern struct gimple_opt_pass pass_warn_unused_result;
-extern struct gimple_opt_pass pass_diagnose_tm_blocks;
-extern struct gimple_opt_pass pass_lower_tm;
-extern struct gimple_opt_pass pass_tm_init;
-extern struct gimple_opt_pass pass_tm_mark;
-extern struct gimple_opt_pass pass_tm_memopt;
-extern struct gimple_opt_pass pass_tm_edges;
-extern struct gimple_opt_pass pass_split_functions;
-extern struct gimple_opt_pass pass_feedback_split_functions;
-extern struct gimple_opt_pass pass_strength_reduction;
+extern gimple_opt_pass *make_pass_profile (context &ctxt);
+extern gimple_opt_pass *make_pass_strip_predict_hints (context &ctxt);
+extern gimple_opt_pass *make_pass_lower_complex_O0 (context &ctxt);
+extern gimple_opt_pass *make_pass_lower_complex (context &ctxt);
+extern gimple_opt_pass *make_pass_lower_vector (context &ctxt);
+extern gimple_opt_pass *make_pass_lower_vector_ssa (context &ctxt);
+extern gimple_opt_pass *make_pass_lower_omp (context &ctxt);
+extern gimple_opt_pass *make_pass_diagnose_omp_blocks (context &ctxt);
+extern gimple_opt_pass *make_pass_expand_omp (context &ctxt);
+extern gimple_opt_pass *make_pass_expand_omp_ssa (context &ctxt);
+extern gimple_opt_pass *make_pass_object_sizes (context &ctxt);
+extern gimple_opt_pass *make_pass_strlen (context &ctxt);
+extern gimple_opt_pass *make_pass_fold_builtins (context &ctxt);
+extern gimple_opt_pass *make_pass_stdarg (context &ctxt);
+extern gimple_opt_pass *make_pass_early_warn_uninitialized (context &ctxt);
+extern gimple_opt_pass *make_pass_late_warn_uninitialized (context &ctxt);
+extern gimple_opt_pass *make_pass_cse_reciprocals (context &ctxt);
+extern gimple_opt_pass *make_pass_cse_sincos (context &ctxt);
+extern gimple_opt_pass *make_pass_optimize_bswap (context &ctxt);
+extern gimple_opt_pass *make_pass_optimize_widening_mul (context &ctxt);
+extern gimple_opt_pass *make_pass_warn_function_return (context &ctxt);
+extern gimple_opt_pass *make_pass_warn_function_noreturn (context &ctxt);
+extern gimple_opt_pass *make_pass_cselim (context &ctxt);
+extern gimple_opt_pass *make_pass_phiopt (context &ctxt);
+extern gimple_opt_pass *make_pass_forwprop (context &ctxt);
+extern gimple_opt_pass *make_pass_phiprop (context &ctxt);
+extern gimple_opt_pass *make_pass_tree_ifcombine (context &ctxt);
+extern gimple_opt_pass *make_pass_dse (context &ctxt);
+extern gimple_opt_pass *make_pass_nrv (context &ctxt);
+extern gimple_opt_pass *make_pass_rename_ssa_copies (context &ctxt);
+extern gimple_opt_pass *make_pass_sink_code (context &ctxt);
+extern gimple_opt_pass *make_pass_fre (context &ctxt);
+extern gimple_opt_pass *make_pass_check_data_deps (context &ctxt);
+extern gimple_opt_pass *make_pass_copy_prop (context &ctxt);
+extern gimple_opt_pass *make_pass_vrp (context &ctxt);
+extern gimple_opt_pass *make_pass_uncprop (context &ctxt);
+extern gimple_opt_pass *make_pass_return_slot (context &ctxt);
+extern gimple_opt_pass *make_pass_reassoc (context &ctxt);
+extern gimple_opt_pass *make_pass_rebuild_cgraph_edges (context &ctxt);
+extern gimple_opt_pass *make_pass_remove_cgraph_callee_edges (context &ctxt);
+extern gimple_opt_pass *make_pass_build_cgraph_edges (context &ctxt);
+extern gimple_opt_pass *make_pass_local_pure_const (context &ctxt);
+extern gimple_opt_pass *make_pass_tracer (context &ctxt);
+extern gimple_opt_pass *make_pass_warn_unused_result (context &ctxt);
+extern gimple_opt_pass *make_pass_diagnose_tm_blocks (context &ctxt);
+extern gimple_opt_pass *make_pass_lower_tm (context &ctxt);
+extern gimple_opt_pass *make_pass_tm_init (context &ctxt);
+extern gimple_opt_pass *make_pass_tm_mark (context &ctxt);
+extern gimple_opt_pass *make_pass_tm_memopt (context &ctxt);
+extern gimple_opt_pass *make_pass_tm_edges (context &ctxt);
+extern gimple_opt_pass *make_pass_split_functions (context &ctxt);
+extern gimple_opt_pass *make_pass_feedback_split_functions (context &ctxt);
+extern gimple_opt_pass *make_pass_strength_reduction (context &ctxt);
 
 /* IPA Passes */
-extern struct simple_ipa_opt_pass pass_ipa_lower_emutls;
-extern struct simple_ipa_opt_pass pass_ipa_function_and_variable_visibility;
-extern struct simple_ipa_opt_pass pass_ipa_tree_profile;
-
-extern struct simple_ipa_opt_pass pass_early_local_passes;
-
-extern struct ipa_opt_pass_d pass_ipa_whole_program_visibility;
-extern struct ipa_opt_pass_d pass_ipa_lto_gimple_out;
-extern struct simple_ipa_opt_pass pass_ipa_increase_alignment;
-extern struct ipa_opt_pass_d pass_ipa_inline;
-extern struct simple_ipa_opt_pass pass_ipa_free_lang_data;
-extern struct simple_ipa_opt_pass pass_ipa_free_inline_summary;
-extern struct ipa_opt_pass_d pass_ipa_cp;
-extern struct ipa_opt_pass_d pass_ipa_reference;
-extern struct ipa_opt_pass_d pass_ipa_pure_const;
-extern struct simple_ipa_opt_pass pass_ipa_pta;
-extern struct ipa_opt_pass_d pass_ipa_lto_wpa_fixup;
-extern struct ipa_opt_pass_d pass_ipa_lto_finish_out;
-extern struct simple_ipa_opt_pass pass_ipa_tm;
-extern struct ipa_opt_pass_d pass_ipa_profile;
-extern struct ipa_opt_pass_d pass_ipa_cdtor_merge;
-
-extern struct gimple_opt_pass pass_cleanup_cfg_post_optimizing;
-extern struct gimple_opt_pass pass_init_datastructures;
-extern struct gimple_opt_pass pass_fixup_cfg;
-
-extern struct rtl_opt_pass pass_expand;
-extern struct rtl_opt_pass pass_instantiate_virtual_regs;
-extern struct rtl_opt_pass pass_rtl_fwprop;
-extern struct rtl_opt_pass pass_rtl_fwprop_addr;
-extern struct rtl_opt_pass pass_jump;
-extern struct rtl_opt_pass pass_jump2;
-extern struct rtl_opt_pass pass_lower_subreg;
-extern struct rtl_opt_pass pass_cse;
-extern struct rtl_opt_pass pass_fast_rtl_dce;
-extern struct rtl_opt_pass pass_ud_rtl_dce;
-extern struct rtl_opt_pass pass_rtl_dce;
-extern struct rtl_opt_pass pass_rtl_dse1;
-extern struct rtl_opt_pass pass_rtl_dse2;
-extern struct rtl_opt_pass pass_rtl_dse3;
-extern struct rtl_opt_pass pass_rtl_cprop;
-extern struct rtl_opt_pass pass_rtl_pre;
-extern struct rtl_opt_pass pass_rtl_hoist;
-extern struct rtl_opt_pass pass_rtl_store_motion;
-extern struct rtl_opt_pass pass_cse_after_global_opts;
-extern struct rtl_opt_pass pass_rtl_ifcvt;
-
-extern struct rtl_opt_pass pass_into_cfg_layout_mode;
-extern struct rtl_opt_pass pass_outof_cfg_layout_mode;
-
-extern struct rtl_opt_pass pass_loop2;
-extern struct rtl_opt_pass pass_rtl_loop_init;
-extern struct rtl_opt_pass pass_rtl_move_loop_invariants;
-extern struct rtl_opt_pass pass_rtl_unswitch;
-extern struct rtl_opt_pass pass_rtl_unroll_and_peel_loops;
-extern struct rtl_opt_pass pass_rtl_doloop;
-extern struct rtl_opt_pass pass_rtl_loop_done;
-
-extern struct rtl_opt_pass pass_web;
-extern struct rtl_opt_pass pass_cse2;
-extern struct rtl_opt_pass pass_df_initialize_opt;
-extern struct rtl_opt_pass pass_df_initialize_no_opt;
-extern struct rtl_opt_pass pass_reginfo_init;
-extern struct rtl_opt_pass pass_inc_dec;
-extern struct rtl_opt_pass pass_stack_ptr_mod;
-extern struct rtl_opt_pass pass_initialize_regs;
-extern struct rtl_opt_pass pass_combine;
-extern struct rtl_opt_pass pass_if_after_combine;
-extern struct rtl_opt_pass pass_ree;
-extern struct rtl_opt_pass pass_partition_blocks;
-extern struct rtl_opt_pass pass_match_asm_constraints;
-extern struct rtl_opt_pass pass_regmove;
-extern struct rtl_opt_pass pass_split_all_insns;
-extern struct rtl_opt_pass pass_fast_rtl_byte_dce;
-extern struct rtl_opt_pass pass_lower_subreg2;
-extern struct rtl_opt_pass pass_mode_switching;
-extern struct rtl_opt_pass pass_sms;
-extern struct rtl_opt_pass pass_sched;
-extern struct rtl_opt_pass pass_ira;
-extern struct rtl_opt_pass pass_reload;
-extern struct rtl_opt_pass pass_clean_state;
-extern struct rtl_opt_pass pass_branch_prob;
-extern struct rtl_opt_pass pass_value_profile_transformations;
-extern struct rtl_opt_pass pass_postreload_cse;
-extern struct rtl_opt_pass pass_gcse2;
-extern struct rtl_opt_pass pass_split_after_reload;
-extern struct rtl_opt_pass pass_branch_target_load_optimize1;
-extern struct rtl_opt_pass pass_thread_prologue_and_epilogue;
-extern struct rtl_opt_pass pass_stack_adjustments;
-extern struct rtl_opt_pass pass_peephole2;
-extern struct rtl_opt_pass pass_if_after_reload;
-extern struct rtl_opt_pass pass_regrename;
-extern struct rtl_opt_pass pass_cprop_hardreg;
-extern struct rtl_opt_pass pass_reorder_blocks;
-extern struct rtl_opt_pass pass_branch_target_load_optimize2;
-extern struct rtl_opt_pass pass_leaf_regs;
-extern struct rtl_opt_pass pass_split_before_sched2;
-extern struct rtl_opt_pass pass_compare_elim_after_reload;
-extern struct rtl_opt_pass pass_sched2;
-extern struct rtl_opt_pass pass_stack_regs;
-extern struct rtl_opt_pass pass_stack_regs_run;
-extern struct rtl_opt_pass pass_df_finish;
-extern struct rtl_opt_pass pass_compute_alignments;
-extern struct rtl_opt_pass pass_duplicate_computed_gotos;
-extern struct rtl_opt_pass pass_variable_tracking;
-extern struct rtl_opt_pass pass_free_cfg;
-extern struct rtl_opt_pass pass_machine_reorg;
-extern struct rtl_opt_pass pass_cleanup_barriers;
-extern struct rtl_opt_pass pass_delay_slots;
-extern struct rtl_opt_pass pass_split_for_shorten_branches;
-extern struct rtl_opt_pass pass_split_before_regstack;
-extern struct rtl_opt_pass pass_convert_to_eh_region_ranges;
-extern struct rtl_opt_pass pass_shorten_branches;
-extern struct rtl_opt_pass pass_set_nothrow_function_flags;
-extern struct rtl_opt_pass pass_dwarf2_frame;
-extern struct rtl_opt_pass pass_final;
-extern struct rtl_opt_pass pass_rtl_seqabstr;
-extern struct gimple_opt_pass pass_release_ssa_names;
-extern struct gimple_opt_pass pass_early_inline;
-extern struct gimple_opt_pass pass_inline_parameters;
-extern struct gimple_opt_pass pass_update_address_taken;
-extern struct gimple_opt_pass pass_convert_switch;
+extern simple_ipa_opt_pass *make_pass_ipa_lower_emutls (context &ctxt);
+extern simple_ipa_opt_pass *make_pass_ipa_function_and_variable_visibility (context &ctxt);
+extern simple_ipa_opt_pass *make_pass_ipa_tree_profile (context &ctxt);
+
+extern simple_ipa_opt_pass *make_pass_early_local_passes (context &ctxt);
+
+extern ipa_opt_pass_d *make_pass_ipa_whole_program_visibility (context &ctxt);
+extern ipa_opt_pass_d *make_pass_ipa_lto_gimple_out (context &ctxt);
+extern simple_ipa_opt_pass *make_pass_ipa_increase_alignment (context &ctxt);
+extern ipa_opt_pass_d *make_pass_ipa_inline (context &ctxt);
+extern simple_ipa_opt_pass *make_pass_ipa_free_lang_data (context &ctxt);
+extern simple_ipa_opt_pass *make_pass_ipa_free_inline_summary (context &ctxt);
+extern ipa_opt_pass_d *make_pass_ipa_cp (context &ctxt);
+extern ipa_opt_pass_d *make_pass_ipa_reference (context &ctxt);
+extern ipa_opt_pass_d *make_pass_ipa_pure_const (context &ctxt);
+extern simple_ipa_opt_pass *make_pass_ipa_pta (context &ctxt);
+extern ipa_opt_pass_d *make_pass_ipa_lto_wpa_fixup (context &ctxt);
+extern ipa_opt_pass_d *make_pass_ipa_lto_finish_out (context &ctxt);
+extern simple_ipa_opt_pass *make_pass_ipa_tm (context &ctxt);
+extern ipa_opt_pass_d *make_pass_ipa_profile (context &ctxt);
+extern ipa_opt_pass_d *make_pass_ipa_cdtor_merge (context &ctxt);
+
+extern gimple_opt_pass *make_pass_cleanup_cfg_post_optimizing (context &ctxt);
+extern gimple_opt_pass *make_pass_init_datastructures (context &ctxt);
+extern gimple_opt_pass *make_pass_fixup_cfg (context &ctxt);
+
+extern rtl_opt_pass *make_pass_expand (context &ctxt);
+extern rtl_opt_pass *make_pass_instantiate_virtual_regs (context &ctxt);
+extern rtl_opt_pass *make_pass_rtl_fwprop (context &ctxt);
+extern rtl_opt_pass *make_pass_rtl_fwprop_addr (context &ctxt);
+extern rtl_opt_pass *make_pass_jump (context &ctxt);
+extern rtl_opt_pass *make_pass_jump2 (context &ctxt);
+extern rtl_opt_pass *make_pass_lower_subreg (context &ctxt);
+extern rtl_opt_pass *make_pass_cse (context &ctxt);
+extern rtl_opt_pass *make_pass_fast_rtl_dce (context &ctxt);
+extern rtl_opt_pass *make_pass_ud_rtl_dce (context &ctxt);
+extern rtl_opt_pass *make_pass_rtl_dce (context &ctxt);
+extern rtl_opt_pass *make_pass_rtl_dse1 (context &ctxt);
+extern rtl_opt_pass *make_pass_rtl_dse2 (context &ctxt);
+extern rtl_opt_pass *make_pass_rtl_dse3 (context &ctxt);
+extern rtl_opt_pass *make_pass_rtl_cprop (context &ctxt);
+extern rtl_opt_pass *make_pass_rtl_pre (context &ctxt);
+extern rtl_opt_pass *make_pass_rtl_hoist (context &ctxt);
+extern rtl_opt_pass *make_pass_rtl_store_motion (context &ctxt);
+extern rtl_opt_pass *make_pass_cse_after_global_opts (context &ctxt);
+extern rtl_opt_pass *make_pass_rtl_ifcvt (context &ctxt);
+
+extern rtl_opt_pass *make_pass_into_cfg_layout_mode (context &ctxt);
+extern rtl_opt_pass *make_pass_outof_cfg_layout_mode (context &ctxt);
+
+extern rtl_opt_pass *make_pass_loop2 (context &ctxt);
+extern rtl_opt_pass *make_pass_rtl_loop_init (context &ctxt);
+extern rtl_opt_pass *make_pass_rtl_move_loop_invariants (context &ctxt);
+extern rtl_opt_pass *make_pass_rtl_unswitch (context &ctxt);
+extern rtl_opt_pass *make_pass_rtl_unroll_and_peel_loops (context &ctxt);
+extern rtl_opt_pass *make_pass_rtl_doloop (context &ctxt);
+extern rtl_opt_pass *make_pass_rtl_loop_done (context &ctxt);
+
+extern rtl_opt_pass *make_pass_web (context &ctxt);
+extern rtl_opt_pass *make_pass_cse2 (context &ctxt);
+extern rtl_opt_pass *make_pass_df_initialize_opt (context &ctxt);
+extern rtl_opt_pass *make_pass_df_initialize_no_opt (context &ctxt);
+extern rtl_opt_pass *make_pass_reginfo_init (context &ctxt);
+extern rtl_opt_pass *make_pass_inc_dec (context &ctxt);
+extern rtl_opt_pass *make_pass_stack_ptr_mod (context &ctxt);
+extern rtl_opt_pass *make_pass_initialize_regs (context &ctxt);
+extern rtl_opt_pass *make_pass_combine (context &ctxt);
+extern rtl_opt_pass *make_pass_if_after_combine (context &ctxt);
+extern rtl_opt_pass *make_pass_ree (context &ctxt);
+extern rtl_opt_pass *make_pass_partition_blocks (context &ctxt);
+extern rtl_opt_pass *make_pass_match_asm_constraints (context &ctxt);
+extern rtl_opt_pass *make_pass_regmove (context &ctxt);
+extern rtl_opt_pass *make_pass_split_all_insns (context &ctxt);
+extern rtl_opt_pass *make_pass_fast_rtl_byte_dce (context &ctxt);
+extern rtl_opt_pass *make_pass_lower_subreg2 (context &ctxt);
+extern rtl_opt_pass *make_pass_mode_switching (context &ctxt);
+extern rtl_opt_pass *make_pass_sms (context &ctxt);
+extern rtl_opt_pass *make_pass_sched (context &ctxt);
+extern rtl_opt_pass *make_pass_ira (context &ctxt);
+extern rtl_opt_pass *make_pass_reload (context &ctxt);
+extern rtl_opt_pass *make_pass_clean_state (context &ctxt);
+extern rtl_opt_pass *make_pass_branch_prob (context &ctxt);
+extern rtl_opt_pass *make_pass_value_profile_transformations (context &ctxt);
+extern rtl_opt_pass *make_pass_postreload_cse (context &ctxt);
+extern rtl_opt_pass *make_pass_gcse2 (context &ctxt);
+extern rtl_opt_pass *make_pass_split_after_reload (context &ctxt);
+extern rtl_opt_pass *make_pass_branch_target_load_optimize1 (context &ctxt);
+extern rtl_opt_pass *make_pass_thread_prologue_and_epilogue (context &ctxt);
+extern rtl_opt_pass *make_pass_stack_adjustments (context &ctxt);
+extern rtl_opt_pass *make_pass_peephole2 (context &ctxt);
+extern rtl_opt_pass *make_pass_if_after_reload (context &ctxt);
+extern rtl_opt_pass *make_pass_regrename (context &ctxt);
+extern rtl_opt_pass *make_pass_cprop_hardreg (context &ctxt);
+extern rtl_opt_pass *make_pass_reorder_blocks (context &ctxt);
+extern rtl_opt_pass *make_pass_branch_target_load_optimize2 (context &ctxt);
+extern rtl_opt_pass *make_pass_leaf_regs (context &ctxt);
+extern rtl_opt_pass *make_pass_split_before_sched2 (context &ctxt);
+extern rtl_opt_pass *make_pass_compare_elim_after_reload (context &ctxt);
+extern rtl_opt_pass *make_pass_sched2 (context &ctxt);
+extern rtl_opt_pass *make_pass_stack_regs (context &ctxt);
+extern rtl_opt_pass *make_pass_stack_regs_run (context &ctxt);
+extern rtl_opt_pass *make_pass_df_finish (context &ctxt);
+extern rtl_opt_pass *make_pass_compute_alignments (context &ctxt);
+extern rtl_opt_pass *make_pass_duplicate_computed_gotos (context &ctxt);
+extern rtl_opt_pass *make_pass_variable_tracking (context &ctxt);
+extern rtl_opt_pass *make_pass_free_cfg (context &ctxt);
+extern rtl_opt_pass *make_pass_machine_reorg (context &ctxt);
+extern rtl_opt_pass *make_pass_cleanup_barriers (context &ctxt);
+extern rtl_opt_pass *make_pass_delay_slots (context &ctxt);
+extern rtl_opt_pass *make_pass_split_for_shorten_branches (context &ctxt);
+extern rtl_opt_pass *make_pass_split_before_regstack (context &ctxt);
+extern rtl_opt_pass *make_pass_convert_to_eh_region_ranges (context &ctxt);
+extern rtl_opt_pass *make_pass_shorten_branches (context &ctxt);
+extern rtl_opt_pass *make_pass_set_nothrow_function_flags (context &ctxt);
+extern rtl_opt_pass *make_pass_dwarf2_frame (context &ctxt);
+extern rtl_opt_pass *make_pass_final (context &ctxt);
+extern rtl_opt_pass *make_pass_rtl_seqabstr (context &ctxt);
+extern gimple_opt_pass *make_pass_release_ssa_names (context &ctxt);
+extern gimple_opt_pass *make_pass_early_inline (context &ctxt);
+extern gimple_opt_pass *make_pass_inline_parameters (context &ctxt);
+extern gimple_opt_pass *make_pass_update_address_taken (context &ctxt);
+extern gimple_opt_pass *make_pass_convert_switch (context &ctxt);
 
 /* The root of the compilation pass tree, once constructed.  */
 extern struct opt_pass *all_passes, *all_small_ipa_passes, *all_lowering_passes,
diff --git a/gcc/tree-profile.c b/gcc/tree-profile.c
index 9985b40..ede83b8 100644
--- a/gcc/tree-profile.c
+++ b/gcc/tree-profile.c
@@ -561,24 +561,34 @@ gate_tree_profile_ipa (void)
 	      || profile_arc_flag));
 }
 
-struct simple_ipa_opt_pass pass_ipa_tree_profile =
+class pass_ipa_tree_profile : public simple_ipa_opt_pass
 {
- {
-  SIMPLE_IPA_PASS,
-  "profile",  		               /* name */
-  OPTGROUP_NONE,                       /* optinfo_flags */
-  gate_tree_profile_ipa,               /* gate */
-  tree_profiling,                      /* execute */
-  NULL,                                /* sub */
-  NULL,                                /* next */
-  0,                                   /* static_pass_number */
-  TV_IPA_PROFILE,                      /* tv_id */
-  0,                                   /* properties_required */
-  0,                                   /* properties_provided */
-  0,                                   /* properties_destroyed */
-  0,                                   /* todo_flags_start */
-  0                                    /* todo_flags_finish */
- }
-};
+public:
+  pass_ipa_tree_profile(context &ctxt)
+    : simple_ipa_opt_pass(ctxt,
+			  "profile",
+			  OPTGROUP_NONE,
+			  TV_IPA_PROFILE,
+			  pass_properties(required(0),
+					  provided(0),
+					  destroyed(0)),
+			  pass_todo_flags(start(0),
+					  finish(0)))
+  {}
+
+  /* opt_pass methods: */
+  bool has_gate () { return true; }
+  bool gate () { return gate_tree_profile_ipa (); }
+
+  bool has_execute () { return true; }
+  unsigned int impl_execute () { return tree_profiling (); }
+
+}; // class pass_ipa_tree_profile
+
+simple_ipa_opt_pass *
+make_pass_ipa_tree_profile (context &ctxt)
+{
+  return new pass_ipa_tree_profile (ctxt);
+}
 
 #include "gt-tree-profile.h"
diff --git a/gcc/tree-sra.c b/gcc/tree-sra.c
index a148a60..d78debf 100644
--- a/gcc/tree-sra.c
+++ b/gcc/tree-sra.c
@@ -3433,47 +3433,65 @@ gate_intra_sra (void)
 }
 
 
-struct gimple_opt_pass pass_sra_early =
+class pass_sra_early : public gimple_opt_pass
 {
- {
-  GIMPLE_PASS,
-  "esra",	 			/* name */
-  OPTGROUP_NONE,                        /* optinfo_flags */
-  gate_intra_sra,			/* gate */
-  early_intra_sra,			/* execute */
-  NULL,					/* sub */
-  NULL,					/* next */
-  0,					/* static_pass_number */
-  TV_TREE_SRA,				/* tv_id */
-  PROP_cfg | PROP_ssa,                  /* properties_required */
-  0,					/* properties_provided */
-  0,					/* properties_destroyed */
-  0,					/* todo_flags_start */
-  TODO_update_ssa
-  | TODO_verify_ssa			/* todo_flags_finish */
- }
-};
+public:
+  pass_sra_early(context &ctxt)
+    : gimple_opt_pass(ctxt,
+		      "esra",
+		      OPTGROUP_NONE,
+		      TV_TREE_SRA,
+		      pass_properties(required(PROP_cfg | PROP_ssa),
+				      provided(0),
+				      destroyed(0)),
+		      pass_todo_flags(start(0),
+				      finish(TODO_update_ssa | TODO_verify_ssa)))
+  {}
+
+  /* opt_pass methods: */
+  bool has_gate () { return true; }
+  bool gate () { return gate_intra_sra (); }
+
+  bool has_execute () { return true; }
+  unsigned int impl_execute () { return early_intra_sra (); }
+
+}; // class pass_sra_early
+
+gimple_opt_pass *
+make_pass_sra_early (context &ctxt)
+{
+  return new pass_sra_early (ctxt);
+}
 
-struct gimple_opt_pass pass_sra =
+class pass_sra : public gimple_opt_pass
 {
- {
-  GIMPLE_PASS,
-  "sra",	 			/* name */
-  OPTGROUP_NONE,                        /* optinfo_flags */
-  gate_intra_sra,			/* gate */
-  late_intra_sra,			/* execute */
-  NULL,					/* sub */
-  NULL,					/* next */
-  0,					/* static_pass_number */
-  TV_TREE_SRA,				/* tv_id */
-  PROP_cfg | PROP_ssa,                  /* properties_required */
-  0,					/* properties_provided */
-  0,					/* properties_destroyed */
-  TODO_update_address_taken,		/* todo_flags_start */
-  TODO_update_ssa
-  | TODO_verify_ssa			/* todo_flags_finish */
- }
-};
+public:
+  pass_sra(context &ctxt)
+    : gimple_opt_pass(ctxt,
+		      "sra",
+		      OPTGROUP_NONE,
+		      TV_TREE_SRA,
+		      pass_properties(required(PROP_cfg | PROP_ssa),
+				      provided(0),
+				      destroyed(0)),
+		      pass_todo_flags(start(TODO_update_address_taken),
+				      finish(TODO_update_ssa | TODO_verify_ssa)))
+  {}
+
+  /* opt_pass methods: */
+  bool has_gate () { return true; }
+  bool gate () { return gate_intra_sra (); }
+
+  bool has_execute () { return true; }
+  unsigned int impl_execute () { return late_intra_sra (); }
+
+}; // class pass_sra
+
+gimple_opt_pass *
+make_pass_sra (context &ctxt)
+{
+  return new pass_sra (ctxt);
+}
 
 
 /* Return true iff PARM (which must be a parm_decl) is an unused scalar
@@ -5009,22 +5027,32 @@ ipa_early_sra_gate (void)
   return flag_ipa_sra && dbg_cnt (eipa_sra);
 }
 
-struct gimple_opt_pass pass_early_ipa_sra =
+class pass_early_ipa_sra : public gimple_opt_pass
 {
- {
-  GIMPLE_PASS,
-  "eipa_sra",	 			/* name */
-  OPTGROUP_NONE,                        /* optinfo_flags */
-  ipa_early_sra_gate,			/* gate */
-  ipa_early_sra,			/* execute */
-  NULL,					/* sub */
-  NULL,					/* next */
-  0,					/* static_pass_number */
-  TV_IPA_SRA,				/* tv_id */
-  0,	                                /* properties_required */
-  0,					/* properties_provided */
-  0,					/* properties_destroyed */
-  0,					/* todo_flags_start */
-  TODO_dump_symtab              	/* todo_flags_finish */
- }
-};
+public:
+  pass_early_ipa_sra(context &ctxt)
+    : gimple_opt_pass(ctxt,
+		      "eipa_sra",
+		      OPTGROUP_NONE,
+		      TV_IPA_SRA,
+		      pass_properties(required(0),
+				      provided(0),
+				      destroyed(0)),
+		      pass_todo_flags(start(0),
+				      finish(TODO_dump_symtab)))
+  {}
+
+  /* opt_pass methods: */
+  bool has_gate () { return true; }
+  bool gate () { return ipa_early_sra_gate (); }
+
+  bool has_execute () { return true; }
+  unsigned int impl_execute () { return ipa_early_sra (); }
+
+}; // class pass_early_ipa_sra
+
+gimple_opt_pass *
+make_pass_early_ipa_sra (context &ctxt)
+{
+  return new pass_early_ipa_sra (ctxt);
+}
